package flow;

/**
 * The Data class handles many types of server-side operations including data
 * collection (from a data sources such as a database, or web service), variable
 * assignments and operations (like copying variable values, performing mathematic
 * operations, and collection iteration), conditional evaluation to control callflow
 * execution based on variable values, and logging/tracing statements.
 * 
 * Items created in the getDataActions() method are executed/evaluated in order
 * and if a condional branch condition evaluates to "true" then the branch is
 * activated and the execution of data actions is halted.  If no "true" conditions
 * are encountered, then all data actions will be executed/evaluated and the 
 * application will proceed to the "Default" servlet.
 * Last generated by Orchestration Designer at: 2021-MAR-11  05:08:16 PM
 */
public class Parse extends com.avaya.sce.runtime.Data {

	//{{START:CLASS:FIELDS
	//}}END:CLASS:FIELDS

	/**
	 * Default constructor
	 * Last generated by Orchestration Designer at: 2021-MAR-11  05:08:16 PM
	 */
	public Parse() {
		//{{START:CLASS:CONSTRUCTOR
		super();
		//}}END:CLASS:CONSTRUCTOR
	}

	/**
	 * Returns the Next item which will forward application execution
	 * to the next form in the call flow.
	 * Last generated by Orchestration Designer at: 2021-MAR-16  11:58:44 AM
	 */
	public com.avaya.sce.runtime.Next getNext(com.avaya.sce.runtimecommon.SCESession mySession) {
		com.avaya.sce.runtime.Next next = new com.avaya.sce.runtime.Next("GetNum", "Default");
		next.setDebugId(6);
		return next;
	}
	/**
	 * Create a list of local variables used by items in the data node.
	 * 
	 * This method is generated automatically by the code generator
	 * and should not be manually edited.  Manual edits may be overwritten
	 * by the code generator.
	 * Last generated by Orchestration Designer at: 2021-MAR-16  11:58:44 AM
	 */
	public java.util.Collection<VariableInfo> getLocalVariables(){
		java.util.Collection<VariableInfo> variables = new java.util.ArrayList<VariableInfo>();
		variables.add(VariableInfo.createSimpleVariable("begin", "{\"responseArray\": "));
		variables.add(VariableInfo.createSimpleVariable("end", "}"));

		return variables;
	}
	/**
	 * Creates and conditionally executes operations that have been configured
	 * in the Callflow.  This method will build a collection of operations and
	 * have the framework execute the operations by calling evaluateActions().
	 * If the evaluation causes the framework to forward to a different servlet
	 * then execution stops.
	 * Returning true from this method means that the framework has forwarded the
	 * request to a different servlet.  Returning false means that the default
	 * Next will be invoked.
	 * 
	 * This method is generated automatically by the code generator
	 * and should not be manually edited.  Manual edits may be overwritten
	 * by the code generator.
	 * Last generated by Orchestration Designer at: 2021-MAR-16  11:58:44 AM
	 */
	public boolean executeDataActions(com.avaya.sce.runtimecommon.SCESession mySession) throws Exception {
		java.util.Collection actions = null;

		actions = new java.util.ArrayList(5);
		actions.add(new com.avaya.sce.runtime.varoperations.Concatenate("begin(L)", "jsonstr", false).setDebugId(40));
		actions.add(new com.avaya.sce.runtime.varoperations.Concatenate("begin(L)", "end(L)", false).setDebugId(41));

		//{{START:CODEGEN:EXTENSIONPOINT:com.avaya.sce.pdc.json.jsonparser
		actions.add(new com.avaya.sce.pdc.json.operations.JSONParser("firstarray", "", "begin(L)", "", "responseArray", "" , true).setDebugId(24));
		//}}END:CODEGEN:EXTENSIONPOINT:com.avaya.sce.pdc.json.jsonparser


		//{{START:CODEGEN:EXTENSIONPOINT:com.avaya.sce.pdc.json.jsonparser
		actions.add(new com.avaya.sce.pdc.json.operations.JSONParser("phonenums", "", "firstarray", "", "parameters", "" , true).setDebugId(42));
		//}}END:CODEGEN:EXTENSIONPOINT:com.avaya.sce.pdc.json.jsonparser

		if(evaluateActions(actions, mySession)) {
			return true;
		}
		actions = null;

		// return false if the evaluation of actions did not cause a servlet forward or redirect
		return false;
	}
}
